diff -xconfig -xrename -xgetDomains -xdomainExists -xgetSmiVersions -x'*-stamp' -x'config.*' -xCVS -x.cvsignore -xMakefile -x'.#*' -xtmp -xupdate.sh -xproxyExists -xlistDomain -xsmixx-31.01.tar.gz -xMakefile.in -xconfigure -xaclocal.m4 -r -w -u -N smixx_web/src/stateManager/ifhandler.cxx smixx/src/stateManager/ifhandler.cxx
--- smixx_web/src/stateManager/ifhandler.cxx	2005-08-09 17:57:46.000000000 +0200
+++ smixx/src/stateManager/ifhandler.cxx	2007-03-19 09:55:42.000000000 +0100
@@ -14,106 +14,146 @@
 //---------------------------- Externals ----------
 #include "objectregistrar.hxx"
    extern ObjectRegistrar allSMIObjects;
+   extern int dbg;
 //-------------------------------------------------
 //
 //----------------------------- IfHandler ---------------------------------
 IfHandler::IfHandler() {
-    _numOfObjects = 0;
     return;
 }
 //
 //
 //-----------------------------  isEmpty  ---------------------------------
-bool IfHandler::isEmpty() {
-   if ( _numOfObjects > 0 ) { return 1;}
-   return 0;
-}
+//bool IfHandler::isEmpty() {
+//   if ( _suspendedObjects.numOfEntries() > 0 ) { return 1;}
+//   return 0;
+//}
 //
 //
 //-----------------------------  addSet  ------------------------------------
-void IfHandler::addSet(char* objName, Set_Name* pTobeLocked) {
-//
-   _objNames[_numOfObjects] = objName;
-   _pTobeLocked[_numOfObjects] = pTobeLocked;   
-   _numOfObjects++;
-//
-   if ( _numOfObjects >= 100 ) {
-        cout << " Too many Ifs waiting\n";
-        cout.flush();
-        exit(1);
-   }
-}
-//
-//
-//----------------------------  objectLocked  -----------------------------
-void IfHandler::objectLocked(char* locked, char* requester) {
-//
-//
-   Name objRequester;
+void IfHandler::addSet(Name& objName, Set_Name& tobeLocked) {
 
-   objRequester = requester;
+//    Name tempName = objName;
+    Set_Name* pTobeLocked = &tobeLocked;
+    NmdPtnr tempItem(objName,pTobeLocked);
+    int flg = _suspendedObjects.add(tempItem);
+    assert( flg == 1 );
 
-   for ( int i = 0; i < _numOfObjects; i++ ) {
-         if ( objRequester == _objNames[i] ) {
-             if ( _pTobeLocked[i]->remove(locked) ) {
-#ifdef DEBUF
-                  cout << " To be locked: ";
-                  _pTobeLocked[i]->out();
-                  cout << "\n";
-                  cout.flush();
-#endif
-                  return;
+//debug beg  
+if ( dbg > 5 ) {
+   cout << endl << " ====================== addSet ===========================" << endl
+        << " Object " << objName << " is suspended " << endl
+	<< " tobe-locked set :" << pTobeLocked << " "; pTobeLocked->out(); cout << endl;
+
+    cout << endl << " Current suspended objects : " << endl;
+    _suspendedObjects.out(" ");
+   cout << " ===================================================" << endl;
              }
-             else {
-                  cout << " Locked object not found in the list\n";
-                  cout.flush();
-                  exit(1);
+//debug end
              }
+
+//----------------------------  objectLocked  -----------------------------
+void IfHandler::objectLocked(Name& locked, Name& requester) {
+   int flg;
+   Set_Name* pTobeLocked;
+   
+   flg = findRequester(requester,pTobeLocked);
+   assert (flg == 1);
+//debug beg
+if ( dbg > 5 ) {
+   cout << endl << " ============================ objectLocked =========================" << endl
+       << "  Object : " << locked << " is locked by " << requester << endl
+       << "        whose tobe-locked set is : " << pTobeLocked << "  " ; pTobeLocked->out(); cout << endl;
          }
+//debug end
+
+    flg = pTobeLocked->remove(locked);
+    assert(flg==1);
+    
+//debug beg
+if ( dbg > 5 ) {
+    cout << "  " << locked << " removed from the set " << pTobeLocked << "  " ; pTobeLocked->out(); cout << endl;
+    cout << " ====================================================================" << endl;       
+//debug end
    }
-//
-   cout << " Requesting object not found in ifhandler list\n";
-   cout.flush();
-   exit(1);
 }
 //
 //
 //------------------------------  execute  ---------------------------------
 //
 void IfHandler::execute() {
-//
-   int iex,i;
-//
-   iex = -1;
-//
-   for ( i = 0; i < _numOfObjects; i++ ) {
-        if ( _pTobeLocked[i]->isEmpty() ) {
-             SMIObject *pSMIObj;
-             pSMIObj = allSMIObjects.gimePointer(_objNames[i]);
-             pSMIObj->resume();
-             iex = i;
-             break;
-        }
+   SMIObject* pSMIObjToResume; Name objToResume;
+   int flg;
+
+    flg = findFreeToResumeObject(objToResume);
+    if ( flg == 0 ) { return;}
+
+    pSMIObjToResume = allSMIObjects.gimePointer(objToResume);		     
+      
+//debug beg
+if ( dbg > 5 ) {
+   cout << endl << " ====================== ifHandler.execute() ===========================" << endl
+        << " Object " << objToResume << " tobe-locked set is empty " << endl;
    }
-//
-   if ( iex == -1 ) { return; }
-//
-   _numOfObjects = _numOfObjects - 1;
-   if( _numOfObjects == 0 ) { return; }
-   if( iex == _numOfObjects ) { return; }
-   for ( i = iex; i < _numOfObjects; i++ ) {
-        _objNames[i] = _objNames[i+1];
-        _pTobeLocked[i] = _pTobeLocked[i+1];
+//debug end  	     
+
+    NmdPtnr tmpItem(objToResume,0);
+    flg = _suspendedObjects.remove(tmpItem);
+    assert(flg==1);
+    
+//debug beg
+if ( dbg > 5 ) {
+    cout << " New suspended object list : " << endl;
+    _suspendedObjects.out(" ");
+   cout << endl << " Object : " << objToResume << " resuming execution";    
    } 
+//debug end
+
+
+   pSMIObjToResume->resume();
+   return; 
 }
 //
 //
 //------------------------------  out  --------------------------------------
 // 
 void IfHandler::out() {
-//
-//
-   for ( int i = 0; i < _numOfObjects; i++ ) {
-        _objNames[i].out();
+    _suspendedObjects.out(" ");
+}
+//======================================== findRequester =======================================
+int IfHandler::findRequester(Name& requester, Set_Name*& pTobeLocked) {
+    NmdPtnr val;
+    
+    int nObj = _suspendedObjects.numOfEntries();
+    if ( nObj <= 0 ) { return 0;}
+    
+    _suspendedObjects.reset();
+    
+    while (_suspendedObjects.nextItem(val)) {
+        if ( val.name() == requester ) {
+	    pTobeLocked = static_cast<Set_Name*>(val.pointer());
+	    return 1;
+	}
+    }
+    
+    return 0;
+}
+//======================================== findFreeToResumeObject ===========================================
+int IfHandler::findFreeToResumeObject(Name& objName) {
+    NmdPtnr val; Set_Name* pTobeLocked;
+    
+    int nObj = _suspendedObjects.numOfEntries();
+    if ( nObj <= 0 ) { return 0;}
+    
+    _suspendedObjects.reset();
+    
+    while (_suspendedObjects.nextItem(val)) {
+	pTobeLocked = static_cast<Set_Name*>(val.pointer());
+	if ( pTobeLocked->isEmpty() ) {
+	    objName = val.name();
+	    return 1;
    }
 }
+    
+    return 0;
+} 
diff -xconfig -xrename -xgetDomains -xdomainExists -xgetSmiVersions -x'*-stamp' -x'config.*' -xCVS -x.cvsignore -xMakefile -x'.#*' -xtmp -xupdate.sh -xproxyExists -xlistDomain -xsmixx-31.01.tar.gz -xMakefile.in -xconfigure -xaclocal.m4 -r -w -u -N smixx_web/src/stateManager/ifhandler.hxx smixx/src/stateManager/ifhandler.hxx
--- smixx_web/src/stateManager/ifhandler.hxx	2001-05-16 09:13:26.000000000 +0200
+++ smixx/src/stateManager/ifhandler.hxx	2007-03-19 09:55:42.000000000 +0100
@@ -10,27 +10,31 @@
 #include "typedefs.hxx"
 #include "name.hxx"
 #include "set_name.hxx"
+#include "nmdptnrlist.hxx"
 
 class IfHandler {
    public :
       IfHandler();
 //
-      bool isEmpty();
+//     bool isEmpty();
 //
-      void addSet(char* objName, Set_Name* pTobeLocked);
+      void addSet(Name& objName, Set_Name& tobeLocked);
 //
-      void objectLocked(char* locked, char* requester);
+      void objectLocked(Name& locked, Name& requester);
 //
       void execute();
 //
       void out() ;
+      
 //
 //
    private :
-      int _numOfObjects;
 
-      Name   _objNames[100];
-      Set_Name* _pTobeLocked[100];
+      int findRequester(Name& requester, Set_Name*& pTobeLocked) ;
+
+      int findFreeToResumeObject(Name& objName) ;      
+      
+      NmdPtnrList _suspendedObjects;
 };
 
 #endif
diff -xconfig -xrename -xgetDomains -xdomainExists -xgetSmiVersions -x'*-stamp' -x'config.*' -xCVS -x.cvsignore -xMakefile -x'.#*' -xtmp -xupdate.sh -xproxyExists -xlistDomain -xsmixx-31.01.tar.gz -xMakefile.in -xconfigure -xaclocal.m4 -r -w -u -N smixx_web/src/stateManager/ifins.cxx smixx/src/stateManager/ifins.cxx
--- smixx_web/src/stateManager/ifins.cxx	2005-08-09 17:57:46.000000000 +0200
+++ smixx/src/stateManager/ifins.cxx	2007-03-19 09:55:42.000000000 +0100
@@ -24,7 +24,7 @@
 //------------------------------ IfIns -------------------------------------
 
  IfIns::IfIns
- ( char lines[][MAXRECL],int lev,InsList* *pAllBlocks,int *no_lines
+ ( char lines[][MAXRECL],int lev, PtrVector& allBlocks,int& no_lines
  , SMIObject *pobj, State *pstat, Action* pact){
 //-------------------------------------------------------------------------
 // Input :
@@ -57,8 +57,8 @@
      int numCondlines;
 
      il++;
-     Condition *tempcnd;     
-     tempcnd = new Condition(&lines[il],&numCondlines);
+     Condition *pCondition;     
+     pCondition = new Condition(&lines[il],&numCondlines);
      il = il + numCondlines;
 
      int ref_blockno,ref_level;
@@ -67,20 +67,20 @@
 //     cout << "Execute block : " << ref_blockno << 
 //             " level : " << ref_level << "\n";
 
-     InsList *tempblk;
-     tempblk = pAllBlocks[ref_blockno];
+     InsList *pInsList;
+     pInsList = static_cast<InsList*>(allBlocks[ref_blockno]);
   
      char condition[MAXRECL];
-     tempcnd->whatAreYou(MAXRECL,condition);
+     pCondition->whatAreYou(MAXRECL,condition);
 //     cout << "Addind condition : " << condition << "\n";
-     _pCondition[icond] = tempcnd;
-     _pblocks[icond] = tempblk; 
-//     cout << icond << "  " << _pblocks[icond] << "\n";
+
+        _conditions += pCondition;
+        _insLists += pInsList;
 
    }
 
 
-  *no_lines = il + 1;
+  no_lines = il + 1;
   return ;
 }
 //
@@ -88,15 +88,27 @@
 
 //------------------------------ whatAreYou ---------------------------------
 void IfIns::whatAreYou(){
+    Condition *pCondition;
+    InsList *pInsList;
+    
 char condition[MAXRECL];
 cout << "\n";
 indent(_level*2+5);
-_pCondition[0]->whatAreYou(MAXRECL,condition);
-cout  << "if " << condition << " then"  << "\n";
-_pblocks[0]->listInstructions();
-//cout << "_pblocks[0] " << _pblocks[0] << "\n";
+
+    pCondition = static_cast<Condition*>(_conditions[0]);
+    pCondition->whatAreYou(MAXRECL,condition);
+
+    cout  << "if " << condition << " then"  << endl;
+    pInsList = static_cast<InsList*>(_insLists[0]);
+
+    indent(_level*2+5);
+    cout << "     " << pInsList << "\n";
+
 for (int i=1; i<_numCond; i++) {
-_pCondition[i]->whatAreYou(MAXRECL,condition);
+
+        pCondition = static_cast<Condition*>(_conditions[i]);
+        pCondition->whatAreYou(MAXRECL,condition);
+
   indent(_level*2+5);
   if (!strcmp(condition,"else")) {
     cout << "else" << "\n";
@@ -104,16 +116,22 @@
   else {
     cout << "else if " << condition << " then"  << "\n";
   }
-  _pblocks[i]->listInstructions();
+        pInsList = static_cast<InsList*>(_insLists[i]);
+
+        indent(_level*2+5);
+        cout << "     " << pInsList << "\n";
 }
 indent(_level*2+5);
-cout << "end if" << "\n" << "\n";
-cout.flush();
+    cout << "end if" << endl << endl;
+    return;
 }
 
 //----------------------------------- execute --------------------------------
-int IfIns::execute(char* pstate){
+int IfIns::execute( Name& endState ){
 //
+    Condition *pCondition;
+    InsList *pInsList;
+
    int trueBlock;
    int returnStat, i;
 
@@ -137,7 +155,7 @@
              cout << "  If suspended...waiting for objects to be locked\n";
 #endif
              _suspend_flag = 1;
-             ifHandler.addSet(_objName.getString(),&_tobeLocked);
+             ifHandler.addSet(_objName,_tobeLocked);
 		freezeConditions();
              return 2;
         } 
@@ -148,7 +166,9 @@
              goto EndIf;
         }
 //
-        returnStat = _pblocks[trueBlock]->execute(pstate);
+        pInsList = static_cast<InsList*>(_insLists[trueBlock]);
+        returnStat = pInsList->execute(endState);
+	
         if (returnStat == 2 ) { 
             _suspend_flag = 2;
             _isuspended = trueBlock;
@@ -177,7 +197,9 @@
              goto EndIf;
         }
 //
-        returnStat = _pblocks[trueBlock]->execute(pstate);
+        pInsList = static_cast<InsList*>(_insLists[trueBlock]);
+        returnStat = pInsList->execute(endState);
+	
         if (returnStat == 2 ) { 
             _suspend_flag = 2;
             _isuspended = trueBlock;
@@ -189,7 +211,9 @@
 //
    else if ( _suspend_flag == 2 ) {            //--------- _suspend_flag == 2
 //
-        returnStat = _pblocks[_isuspended]->execute(pstate);
+        pInsList = static_cast<InsList*>(_insLists[_isuspended]);
+        returnStat = pInsList->execute(endState);
+	
         if (returnStat == 2 ) { 
              return 2; 
         }
@@ -217,7 +241,7 @@
          << this << ")---------------------\n\n";
 #endif
 //   if (returnStat != 0) {
-//   cout << " State :" << pstate << "\n" << "\n";
+//   cout << " State :" << endState << "\n" << "\n";
 //   }
 //
 
@@ -228,6 +252,8 @@
 //
 void IfIns::lockObjects() {
 //
+    Condition *pCondition;
+
    Name obj;
    SMIObject *pSMIObj;
 
@@ -235,11 +261,12 @@
 	        obj = _tobeLocked.element(0);
 		_tobeLocked.remove(obj);
 	}
-
-	_pCondition[0]->objectSet(&_tobeLocked);
+        pCondition = static_cast<Condition*>(_conditions[0]);
+	pCondition->objectSet(&_tobeLocked);
 
 	for ( int iicond = 1; iicond < _numCond; iicond++ ) {
-		_pCondition[iicond]->addto_objectSet(&_tobeLocked);
+	    pCondition = static_cast<Condition*>(_conditions[iicond]);
+	    pCondition->addto_objectSet(&_tobeLocked);
 	}
 
 //
@@ -264,15 +291,19 @@
 //
 void IfIns::unlockObjects() {
 //
+    Condition *pCondition;
+
    if( !_tobeLocked.isEmpty() ){
        cout << " Object set not empty at end if \n";
        exit(1);
    }
 
-   _pCondition[0]->objectSet(&_tobeLocked);
+    pCondition = static_cast<Condition*>(_conditions[0]);
+    pCondition->objectSet(&_tobeLocked);
 
    for ( int iicond = 1; iicond < _numCond; iicond++ ) {
-         _pCondition[iicond]->addto_objectSet(&_tobeLocked);
+       pCondition = static_cast<Condition*>(_conditions[iicond]);
+       pCondition->addto_objectSet(&_tobeLocked);
    }
 
    Name obj;
@@ -291,6 +322,8 @@
 //
 int IfIns::findTrueBlock() {
 //
+    Condition *pCondition;
+
 #ifdef DEBUG
 	cout << " Looking for true condition " << endl;
 #endif
@@ -303,7 +336,8 @@
 #ifdef DEBUG
 	cout << " Condition : " << icond << endl;
 #endif
-         int  cond_flag = _pCondition[icond]->evaluate();
+        pCondition = static_cast<Condition*>(_conditions[icond]);
+        int  cond_flag = pCondition->evaluate();
 
          if ( cond_flag == -1 ) {
               cout << 
@@ -326,15 +360,22 @@
 }
 //--------------------------- freezeConditions -------------------------
 void IfIns::freezeConditions() {
+    Condition *pCondition;
+    InsList *pInsList;
+
 	for ( int icond=0; icond < _numCond; icond++ ) {
-		_pCondition[icond]->freeze();
+            pCondition = static_cast<Condition*>(_conditions[icond]);
+	    pCondition->freeze();
 	}
 	return;
 }
 //--------------------------- unfreezeConditions -----------------------
 void IfIns::unfreezeConditions() {
+    Condition *pCondition;
+
 	for ( int icond=0; icond < _numCond; icond++ ) {
-		_pCondition[icond]->unfreeze();
+	    pCondition = static_cast<Condition*>(_conditions[icond]);
+            pCondition->unfreeze();
 	}
 	return;
 }
diff -xconfig -xrename -xgetDomains -xdomainExists -xgetSmiVersions -x'*-stamp' -x'config.*' -xCVS -x.cvsignore -xMakefile -x'.#*' -xtmp -xupdate.sh -xproxyExists -xlistDomain -xsmixx-31.01.tar.gz -xMakefile.in -xconfigure -xaclocal.m4 -r -w -u -N smixx_web/src/stateManager/ifins.hxx smixx/src/stateManager/ifins.hxx
--- smixx_web/src/stateManager/ifins.hxx	2004-05-26 17:59:22.000000000 +0200
+++ smixx/src/stateManager/ifins.hxx	2006-01-11 14:42:07.000000000 +0100
@@ -19,10 +19,10 @@
 
 class IfIns : public Instruction{
 public :
-  IfIns( char lines[][MAXRECL],int lev,InsList* *pAllBlocks
-       ,int *no_lines, SMIObject *pobj, State* pstat, Action*);
+  IfIns( char lines[][MAXRECL],int lev, PtrVector& allBlocks
+       ,int& no_lines, SMIObject *pobj, State* pstat, Action*);
   void whatAreYou();
-  int execute(char* pstate);   // 0-normal,  1-terminated action, 2-suspended
+  int execute( Name& endState );   // 0-normal,  1-terminated action, 2-suspended
 private:
 //
   void lockObjects();
@@ -35,8 +35,10 @@
   int _level;
   int _numCond;
   Action* _pParentAction;
-  InsList *_pblocks[100];  
-  Condition *_pCondition[100];
+
+    PtrVector _insLists;  // holds the pointers to the instructin Lists
+    PtrVector _conditions; //holds pointers to the corresp. conditions
+    
   int _isuspended;    // block at which it was suspended
   int _suspend_flag;  // non zero means that 'if' was suspended
 //                      1 - suspended because the condition could not be eval
diff -xconfig -xrename -xgetDomains -xdomainExists -xgetSmiVersions -x'*-stamp' -x'config.*' -xCVS -x.cvsignore -xMakefile -x'.#*' -xtmp -xupdate.sh -xproxyExists -xlistDomain -xsmixx-31.01.tar.gz -xMakefile.in -xconfigure -xaclocal.m4 -r -w -u -N smixx_web/src/stateManager/insertins.cxx smixx/src/stateManager/insertins.cxx
--- smixx_web/src/stateManager/insertins.cxx	2005-08-15 17:29:08.000000000 +0200
+++ smixx/src/stateManager/insertins.cxx	2005-09-28 18:41:09.000000000 +0200
@@ -11,6 +11,7 @@
    extern Registrar allSMIObjectSets;
 #include "scheduler.hxx"
    extern Scheduler* pSchedulerGl;
+   extern int dbg;
 //-------------------------------------------------
 #include "insertins.hxx"
 #include "smiobject.hxx"
@@ -51,7 +52,7 @@
 
 
 //----------------------------  execute  ---------------------------------------
-int InsertIns::execute(char* pendState){
+int InsertIns::execute( Name& endState ){
 
 //	Name offset = "     "; char* pOffset = offset.getString();
 //	cout << endl << pOffset;
@@ -84,8 +85,10 @@
 			cout << " No value for parameter " << parName << endl;
 		}
 		else {
-//CG			cout << " Parameter " << parName 
-//			<< " has value " << parVal << endl;
+		    if ( dbg > 2 ) {
+                        cout << " Parameter " << parName 
+                        << " has value " << parVal << endl;
+		    }
 			char* parValchr = parVal.getString(); 
 			parValchr[strlen(parValchr)-1] = '\0';
 			objNm = &parValchr[1];
diff -xconfig -xrename -xgetDomains -xdomainExists -xgetSmiVersions -x'*-stamp' -x'config.*' -xCVS -x.cvsignore -xMakefile -x'.#*' -xtmp -xupdate.sh -xproxyExists -xlistDomain -xsmixx-31.01.tar.gz -xMakefile.in -xconfigure -xaclocal.m4 -r -w -u -N smixx_web/src/stateManager/insertins.hxx smixx/src/stateManager/insertins.hxx
--- smixx_web/src/stateManager/insertins.hxx	2004-05-26 17:41:42.000000000 +0200
+++ smixx/src/stateManager/insertins.hxx	2005-09-28 18:41:09.000000000 +0200
@@ -22,7 +22,7 @@
 
 	void whatAreYou() ;
 
-	int execute(char* pstate);   // 0-normal,  1-terminated action, 2-suspended
+	int execute( Name& endState );   // 0-normal,  1-terminated action, 2-suspended
 private:
 	int _level;
 
diff -xconfig -xrename -xgetDomains -xdomainExists -xgetSmiVersions -x'*-stamp' -x'config.*' -xCVS -x.cvsignore -xMakefile -x'.#*' -xtmp -xupdate.sh -xproxyExists -xlistDomain -xsmixx-31.01.tar.gz -xMakefile.in -xconfigure -xaclocal.m4 -r -w -u -N smixx_web/src/stateManager/inslist.cxx smixx/src/stateManager/inslist.cxx
--- smixx_web/src/stateManager/inslist.cxx	2004-11-11 14:40:56.000000000 +0100
+++ smixx/src/stateManager/inslist.cxx	2006-01-11 14:47:28.000000000 +0100
@@ -29,8 +29,8 @@
   _pParentState = pstat;
 }
 
-void InsList::initialise( char lines[][MAXRECL], InsList* *pblocks, 
-                          int *no_lines){
+void InsList::initialise( char lines[][MAXRECL], PtrVector& allBlocks, 
+                          int& no_lines){
 
   int curr_block, curr_level;   // block number and level of the block
                                 // which is being processed
@@ -42,11 +42,11 @@
   for (int il=2;;il++){
 //    cout << lines[il] << "\n";
     if (!strcmp(lines[il],"*END_ACTION")) {
-       *no_lines = il;
+       no_lines = il;
        break;
     }
     else if (!strcmp(lines[il],"*BLOCK")) {
-       *no_lines = il;
+       no_lines = il;
        break;
     }
 
@@ -96,7 +96,7 @@
 
       IfIns *pIfIns;
       pIfIns = new IfIns
-          (&lines[il],curr_level,pblocks,&no_iflines,
+          (&lines[il],curr_level,allBlocks,no_iflines,
 	  _pParentObject,_pParentState,_pParentAction);
 
 	_instructions += pIfIns;
@@ -129,7 +129,7 @@
 //=========================== listInstructions ===========================
 void InsList::listInstructions(){
 	int numIns = _instructions.length();
-//cout << " Num of instructions : " << numIns << "\n";
+cout << " Num of instructions : " << numIns << "\n";
 if (numIns == 0 ) {return;}
 for( int i=0; i<numIns; i++) {
 	void* ptnv = _instructions[i];
@@ -139,7 +139,8 @@
 }
 
 //==============================  execute  =================================
-int InsList::execute(char* pstate){
+int InsList::execute( Name& endState ){
+    
 	int numIns = _instructions.length();
 int temp;
 #ifdef DEBUG
@@ -160,7 +161,8 @@
 	void* ptnv = _instructions[i];
 	Instruction* ptnI = (Instruction*) ptnv;
 
-   temp = ptnI->execute(pstate);
+   temp = ptnI->execute(endState);
+  
    if (temp == 2) { 
      _isuspended = i; 
 #ifdef DEBUG
diff -xconfig -xrename -xgetDomains -xdomainExists -xgetSmiVersions -x'*-stamp' -x'config.*' -xCVS -x.cvsignore -xMakefile -x'.#*' -xtmp -xupdate.sh -xproxyExists -xlistDomain -xsmixx-31.01.tar.gz -xMakefile.in -xconfigure -xaclocal.m4 -r -w -u -N smixx_web/src/stateManager/inslist.hxx smixx/src/stateManager/inslist.hxx
--- smixx_web/src/stateManager/inslist.hxx	2004-05-26 17:56:02.000000000 +0200
+++ smixx/src/stateManager/inslist.hxx	2006-01-11 14:47:28.000000000 +0100
@@ -23,10 +23,10 @@
 class InsList {
 public :
   InsList(int blknum, int lev, SMIObject *pobj, State*, Action*);
-  void initialise( char lines[][MAXRECL], InsList* *pblocks, 
-                   int *no_lines);
+  void initialise( char lines[][MAXRECL], PtrVector& allBlocks, 
+                   int& no_lines);
   void listInstructions();
-  int execute(char* pstate);
+  int execute( Name& endState );
 private :
   int _block_id;
   int _level;
diff -xconfig -xrename -xgetDomains -xdomainExists -xgetSmiVersions -x'*-stamp' -x'config.*' -xCVS -x.cvsignore -xMakefile -x'.#*' -xtmp -xupdate.sh -xproxyExists -xlistDomain -xsmixx-31.01.tar.gz -xMakefile.in -xconfigure -xaclocal.m4 -r -w -u -N smixx_web/src/stateManager/instruction.hxx smixx/src/stateManager/instruction.hxx
--- smixx_web/src/stateManager/instruction.hxx	2001-05-16 09:13:26.000000000 +0200
+++ smixx/src/stateManager/instruction.hxx	2005-09-28 18:41:09.000000000 +0200
@@ -2,11 +2,12 @@
 #ifndef INSTRUCTION_HH
 #define INSTRUCTION_HH
 
+class Name;
 
 class Instruction {
 public:
   virtual void whatAreYou()  = 0;
-  virtual int execute(char* pstate)  = 0;   // 0-normal,  1-terminated action, 2-suspended
+    virtual int execute(Name& endState)  = 0;   // 0-normal,  1-terminated action, 2-suspended
 };  
 
 #endif
diff -xconfig -xrename -xgetDomains -xdomainExists -xgetSmiVersions -x'*-stamp' -x'config.*' -xCVS -x.cvsignore -xMakefile -x'.#*' -xtmp -xupdate.sh -xproxyExists -xlistDomain -xsmixx-31.01.tar.gz -xMakefile.in -xconfigure -xaclocal.m4 -r -w -u -N smixx_web/src/stateManager/parameters.hxx smixx/src/stateManager/parameters.hxx
--- smixx_web/src/stateManager/parameters.hxx	2005-08-09 17:57:46.000000000 +0200
+++ smixx/src/stateManager/parameters.hxx	2005-10-06 15:58:10.000000000 +0200
@@ -1,7 +1,6 @@
 #ifndef PARAMETERS_HH
 #define PARAMETERS_HH
-#define MAXRECL 81
-#define MAXNAMESIZE 65
+#define MAXRECL 129
 #define MAXSUBOBJECTS 1
 #endif
 //#define DEBUG
diff -xconfig -xrename -xgetDomains -xdomainExists -xgetSmiVersions -x'*-stamp' -x'config.*' -xCVS -x.cvsignore -xMakefile -x'.#*' -xtmp -xupdate.sh -xproxyExists -xlistDomain -xsmixx-31.01.tar.gz -xMakefile.in -xconfigure -xaclocal.m4 -r -w -u -N smixx_web/src/stateManager/scheduler.cxx smixx/src/stateManager/scheduler.cxx
--- smixx_web/src/stateManager/scheduler.cxx	2005-08-15 17:29:08.000000000 +0200
+++ smixx/src/stateManager/scheduler.cxx	2005-09-28 15:33:04.000000000 +0200
@@ -179,8 +179,9 @@
 }
 //----------------------- handleObjectSetWhens ------------------------
 void Scheduler::handleObjectSetWhens() {
-//CG	print_msg("handleObjectSetWhens() called");
-//	cout << "handleObjectSetWhens() called" << endl;
+        if ( dbg > 2 ) {
+            print_msg("handleObjectSetWhens() called");
+	}
 	NameList* ptnL = &_reqObjectSetList;
 	ptnL->reset();
 	Name setName; Name temp;
@@ -195,7 +196,9 @@
 	}
 	ptnL->removeAll();
 
-//CG	print_msg("handleObjectSetWhens() finished");	
+        if ( dbg > 2 ) {
+            print_msg("handleObjectSetWhens() finished");
+	}	
 	return;
 }
 //----------------------------------------------------------------------------
diff -xconfig -xrename -xgetDomains -xdomainExists -xgetSmiVersions -x'*-stamp' -x'config.*' -xCVS -x.cvsignore -xMakefile -x'.#*' -xtmp -xupdate.sh -xproxyExists -xlistDomain -xsmixx-31.01.tar.gz -xMakefile.in -xconfigure -xaclocal.m4 -r -w -u -N smixx_web/src/stateManager/setins.cxx smixx/src/stateManager/setins.cxx
--- smixx_web/src/stateManager/setins.cxx	2004-11-25 20:58:20.000000000 +0100
+++ smixx/src/stateManager/setins.cxx	2005-09-28 18:41:09.000000000 +0200
@@ -145,7 +145,7 @@
 //----------------------------  execute  ---------------------------------------
 //
 //
-int SetIns::execute(char* pendState){
+int SetIns::execute( Name& endState ){
 //
 //
    Parms *pObjParms = _pParentObject->pObjectParameters();
diff -xconfig -xrename -xgetDomains -xdomainExists -xgetSmiVersions -x'*-stamp' -x'config.*' -xCVS -x.cvsignore -xMakefile -x'.#*' -xtmp -xupdate.sh -xproxyExists -xlistDomain -xsmixx-31.01.tar.gz -xMakefile.in -xconfigure -xaclocal.m4 -r -w -u -N smixx_web/src/stateManager/setins.hxx smixx/src/stateManager/setins.hxx
--- smixx_web/src/stateManager/setins.hxx	2004-05-26 17:40:22.000000000 +0200
+++ smixx/src/stateManager/setins.hxx	2005-09-28 18:41:09.000000000 +0200
@@ -21,7 +21,7 @@
       ( char lines[][MAXRECL], const int lev, int& no_lines,
          SMIObject *pobj, State *pstat, Action *pact);
   void whatAreYou() ;
-  int execute(char* pstate);   // 0-normal,  1-terminated action, 2-suspended
+  int execute( Name& endState );   // 0-normal,  1-terminated action, 2-suspended
 private:
   int _level;
 
diff -xconfig -xrename -xgetDomains -xdomainExists -xgetSmiVersions -x'*-stamp' -x'config.*' -xCVS -x.cvsignore -xMakefile -x'.#*' -xtmp -xupdate.sh -xproxyExists -xlistDomain -xsmixx-31.01.tar.gz -xMakefile.in -xconfigure -xaclocal.m4 -r -w -u -N smixx_web/src/stateManager/smiobject.cxx smixx/src/stateManager/smiobject.cxx
--- smixx_web/src/stateManager/smiobject.cxx	2005-08-09 17:57:46.000000000 +0200
+++ smixx/src/stateManager/smiobject.cxx	2007-03-19 09:55:42.000000000 +0100
@@ -55,6 +55,9 @@
    lin = 3;
 
    if ( _classFlag != 0 ) {
+       _associated = 0; // for objects belonging to a class, this is taken 
+                        // from the class and anything comming from the translator
+			// output is ignored
        _className = lines[3];
       lin = 4;
    }
@@ -497,11 +500,7 @@
             cout << " locked by  " << clientObject << "\n";
         }
 
-        char temp[MAXNAMESIZE];
-        clientObject.whatAreYou(temp,MAXNAMESIZE);
-        char objnm_temp[MAXRECL];
-        _objectName.whatAreYou(objnm_temp, MAXRECL);
-        ifHandler.objectLocked(objnm_temp,temp);
+        ifHandler.objectLocked(_objectName,clientObject);
         return;
    }
 //
@@ -533,7 +532,6 @@
 //
 //------------
    int flag,ist;
-   char newState[MAXNAMESIZE];
 
    if ( _associated == 0 ){             // Logical object
         _pCommHandler->publishBusy(this,actionstr.getString());
@@ -740,6 +738,17 @@
   bool SMIObject::associated() const {
      return _associated;
   }
+//-------------------------------------------------------------
+  bool SMIObject::hasAssociatedAttribute() const {
+      int numAt = _attributes.length();
+      if ( numAt <= 0 ) { return 0; }
+      
+      for ( int i=0; i < numAt; i++ ) {
+          if ( _attributes[i] == "ASSOCIATED" ) { return 1; }
+      }
+      
+      return 0;
+  }
 //************************************************************************
 Name SMIObject::externDomain () const {
 
@@ -760,15 +769,6 @@
   Name SMIObject::subobjectName(const int index) const {
      return _subobject[index];
   }
-//*****************************  subobjectName  ****************************
-
-void SMIObject::subobjectName ( int index, char* name ) {
-
-   _subobject[index].whatAreYou(name,MAXNAMESIZE);
-
-   return;
-
-}
 //-------------------------------------------------------------------------
 
 Name SMIObject::currentState() const {
@@ -821,7 +821,7 @@
     State* pState;
     pState = static_cast<State*>(_states.gimePointer(_currStateInx));
         int flag,ist;
-        char newState[MAXNAMESIZE];
+        Name newState;
 //
         flag = pState->execute(_currentActionString, newState);
 //           flag is either -1..action not found
@@ -836,7 +836,7 @@
 //             cout << " action " << _currentActionString 
 //                  << " terminated in state " << newState << endl; cout.flush();
 //           first find out which state it is
-             _currStateInx = stateInx(newState);
+             _currStateInx = stateInx(newState.getString());
 //             cout << " _currStateInx = " << _currStateInx << " \n";
              if ( _currStateInx == -1 ) {    
                 print_obj(_objectName);
@@ -850,7 +850,7 @@
 //             _pStateQ->out();
              { char objnm_temp[MAXRECL];
              _objectName.whatAreYou(objnm_temp, MAXRECL);
-             _pStateQ->add(objnm_temp,newState);}
+             _pStateQ->add(objnm_temp,newState.getString());}
 #ifdef DEBUG
               print_obj(_objectName);
               cout << " end state " << newState << " ->StateQ \n";
diff -xconfig -xrename -xgetDomains -xdomainExists -xgetSmiVersions -x'*-stamp' -x'config.*' -xCVS -x.cvsignore -xMakefile -x'.#*' -xtmp -xupdate.sh -xproxyExists -xlistDomain -xsmixx-31.01.tar.gz -xMakefile.in -xconfigure -xaclocal.m4 -r -w -u -N smixx_web/src/stateManager/smiobject.hxx smixx/src/stateManager/smiobject.hxx
--- smixx_web/src/stateManager/smiobject.hxx	2005-08-09 17:57:46.000000000 +0200
+++ smixx/src/stateManager/smiobject.hxx	2006-03-31 15:49:06.000000000 +0200
@@ -60,14 +60,15 @@
 
   bool associated() const;
 
+  bool hasAssociatedAttribute() const; //this should obviously give the same
+                                       // answer as associated() 
+
   Name externDomain() const;
 
   int name(char* obj_nm, int *numSubobj);	 //returns associated flag
                                                  //can probably be made obsolete
   Name subobjectName(const int index) const;
 
-  void subobjectName(int index, char* name);     //can be made obsolete?
-
   Name currentState() const;
 
   State* pCurrentState( const int subobjinx ) const ;
